package cmvr.api;

import static io.grpc.MethodDescriptor.generateFullMethodName;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.52.0)",
    comments = "Source: cmvr/api/agv_service.proto")
@io.grpc.stub.annotations.GrpcGenerated
public final class AgvServiceGrpc {

  private AgvServiceGrpc() {}

  public static final String SERVICE_NAME = "cmvr.api.AgvService";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request,
      cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback> getGetStatusInfoMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetStatusInfo",
      requestType = cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request.class,
      responseType = cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request,
      cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback> getGetStatusInfoMethod() {
    io.grpc.MethodDescriptor<cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request, cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback> getGetStatusInfoMethod;
    if ((getGetStatusInfoMethod = AgvServiceGrpc.getGetStatusInfoMethod) == null) {
      synchronized (AgvServiceGrpc.class) {
        if ((getGetStatusInfoMethod = AgvServiceGrpc.getGetStatusInfoMethod) == null) {
          AgvServiceGrpc.getGetStatusInfoMethod = getGetStatusInfoMethod =
              io.grpc.MethodDescriptor.<cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request, cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetStatusInfo"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new AgvServiceMethodDescriptorSupplier("GetStatusInfo"))
              .build();
        }
      }
    }
    return getGetStatusInfoMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request,
      cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback> getGetBatteryStatusMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetBatteryStatus",
      requestType = cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request.class,
      responseType = cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request,
      cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback> getGetBatteryStatusMethod() {
    io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request, cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback> getGetBatteryStatusMethod;
    if ((getGetBatteryStatusMethod = AgvServiceGrpc.getGetBatteryStatusMethod) == null) {
      synchronized (AgvServiceGrpc.class) {
        if ((getGetBatteryStatusMethod = AgvServiceGrpc.getGetBatteryStatusMethod) == null) {
          AgvServiceGrpc.getGetBatteryStatusMethod = getGetBatteryStatusMethod =
              io.grpc.MethodDescriptor.<cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request, cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetBatteryStatus"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new AgvServiceMethodDescriptorSupplier("GetBatteryStatus"))
              .build();
        }
      }
    }
    return getGetBatteryStatusMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotStatusLocCommand.Request,
      cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback> getGetRobotLocationMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetRobotLocation",
      requestType = cmvr.api.AgvCommand.RobotStatusLocCommand.Request.class,
      responseType = cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotStatusLocCommand.Request,
      cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback> getGetRobotLocationMethod() {
    io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotStatusLocCommand.Request, cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback> getGetRobotLocationMethod;
    if ((getGetRobotLocationMethod = AgvServiceGrpc.getGetRobotLocationMethod) == null) {
      synchronized (AgvServiceGrpc.class) {
        if ((getGetRobotLocationMethod = AgvServiceGrpc.getGetRobotLocationMethod) == null) {
          AgvServiceGrpc.getGetRobotLocationMethod = getGetRobotLocationMethod =
              io.grpc.MethodDescriptor.<cmvr.api.AgvCommand.RobotStatusLocCommand.Request, cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetRobotLocation"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.RobotStatusLocCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new AgvServiceMethodDescriptorSupplier("GetRobotLocation"))
              .build();
        }
      }
    }
    return getGetRobotLocationMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request,
      cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback> getRobotConfigDownloadMapMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "RobotConfigDownloadMap",
      requestType = cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request.class,
      responseType = cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request,
      cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback> getRobotConfigDownloadMapMethod() {
    io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request, cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback> getRobotConfigDownloadMapMethod;
    if ((getRobotConfigDownloadMapMethod = AgvServiceGrpc.getRobotConfigDownloadMapMethod) == null) {
      synchronized (AgvServiceGrpc.class) {
        if ((getRobotConfigDownloadMapMethod = AgvServiceGrpc.getRobotConfigDownloadMapMethod) == null) {
          AgvServiceGrpc.getRobotConfigDownloadMapMethod = getRobotConfigDownloadMapMethod =
              io.grpc.MethodDescriptor.<cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request, cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "RobotConfigDownloadMap"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new AgvServiceMethodDescriptorSupplier("RobotConfigDownloadMap"))
              .build();
        }
      }
    }
    return getRobotConfigDownloadMapMethod;
  }

  private static volatile io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotStatusMapCommand.Request,
      cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback> getGetMapStatusMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetMapStatus",
      requestType = cmvr.api.AgvCommand.RobotStatusMapCommand.Request.class,
      responseType = cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotStatusMapCommand.Request,
      cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback> getGetMapStatusMethod() {
    io.grpc.MethodDescriptor<cmvr.api.AgvCommand.RobotStatusMapCommand.Request, cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback> getGetMapStatusMethod;
    if ((getGetMapStatusMethod = AgvServiceGrpc.getGetMapStatusMethod) == null) {
      synchronized (AgvServiceGrpc.class) {
        if ((getGetMapStatusMethod = AgvServiceGrpc.getGetMapStatusMethod) == null) {
          AgvServiceGrpc.getGetMapStatusMethod = getGetMapStatusMethod =
              io.grpc.MethodDescriptor.<cmvr.api.AgvCommand.RobotStatusMapCommand.Request, cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetMapStatus"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.RobotStatusMapCommand.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback.getDefaultInstance()))
              .setSchemaDescriptor(new AgvServiceMethodDescriptorSupplier("GetMapStatus"))
              .build();
        }
      }
    }
    return getGetMapStatusMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static AgvServiceStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<AgvServiceStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<AgvServiceStub>() {
        @java.lang.Override
        public AgvServiceStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new AgvServiceStub(channel, callOptions);
        }
      };
    return AgvServiceStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static AgvServiceBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<AgvServiceBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<AgvServiceBlockingStub>() {
        @java.lang.Override
        public AgvServiceBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new AgvServiceBlockingStub(channel, callOptions);
        }
      };
    return AgvServiceBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static AgvServiceFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<AgvServiceFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<AgvServiceFutureStub>() {
        @java.lang.Override
        public AgvServiceFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new AgvServiceFutureStub(channel, callOptions);
        }
      };
    return AgvServiceFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class AgvServiceImplBase implements io.grpc.BindableService {

    /**
     * <pre>
     * 基本控制
     * </pre>
     */
    public void getStatusInfo(cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getGetStatusInfoMethod(), responseObserver);
    }

    /**
     */
    public void getBatteryStatus(cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getGetBatteryStatusMethod(), responseObserver);
    }

    /**
     */
    public void getRobotLocation(cmvr.api.AgvCommand.RobotStatusLocCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getGetRobotLocationMethod(), responseObserver);
    }

    /**
     */
    public void robotConfigDownloadMap(cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getRobotConfigDownloadMapMethod(), responseObserver);
    }

    /**
     */
    public void getMapStatus(cmvr.api.AgvCommand.RobotStatusMapCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getGetMapStatusMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getGetStatusInfoMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request,
                cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback>(
                  this, METHODID_GET_STATUS_INFO)))
          .addMethod(
            getGetBatteryStatusMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request,
                cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback>(
                  this, METHODID_GET_BATTERY_STATUS)))
          .addMethod(
            getGetRobotLocationMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.AgvCommand.RobotStatusLocCommand.Request,
                cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback>(
                  this, METHODID_GET_ROBOT_LOCATION)))
          .addMethod(
            getRobotConfigDownloadMapMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request,
                cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback>(
                  this, METHODID_ROBOT_CONFIG_DOWNLOAD_MAP)))
          .addMethod(
            getGetMapStatusMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                cmvr.api.AgvCommand.RobotStatusMapCommand.Request,
                cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback>(
                  this, METHODID_GET_MAP_STATUS)))
          .build();
    }
  }

  /**
   */
  public static final class AgvServiceStub extends io.grpc.stub.AbstractAsyncStub<AgvServiceStub> {
    private AgvServiceStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected AgvServiceStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new AgvServiceStub(channel, callOptions);
    }

    /**
     * <pre>
     * 基本控制
     * </pre>
     */
    public void getStatusInfo(cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getGetStatusInfoMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getBatteryStatus(cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getGetBatteryStatusMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getRobotLocation(cmvr.api.AgvCommand.RobotStatusLocCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getGetRobotLocationMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void robotConfigDownloadMap(cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getRobotConfigDownloadMapMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public void getMapStatus(cmvr.api.AgvCommand.RobotStatusMapCommand.Request request,
        io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getGetMapStatusMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class AgvServiceBlockingStub extends io.grpc.stub.AbstractBlockingStub<AgvServiceBlockingStub> {
    private AgvServiceBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected AgvServiceBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new AgvServiceBlockingStub(channel, callOptions);
    }

    /**
     * <pre>
     * 基本控制
     * </pre>
     */
    public cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback getStatusInfo(cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getGetStatusInfoMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback getBatteryStatus(cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getGetBatteryStatusMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback getRobotLocation(cmvr.api.AgvCommand.RobotStatusLocCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getGetRobotLocationMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback robotConfigDownloadMap(cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getRobotConfigDownloadMapMethod(), getCallOptions(), request);
    }

    /**
     */
    public cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback getMapStatus(cmvr.api.AgvCommand.RobotStatusMapCommand.Request request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getGetMapStatusMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class AgvServiceFutureStub extends io.grpc.stub.AbstractFutureStub<AgvServiceFutureStub> {
    private AgvServiceFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected AgvServiceFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new AgvServiceFutureStub(channel, callOptions);
    }

    /**
     * <pre>
     * 基本控制
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback> getStatusInfo(
        cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getGetStatusInfoMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback> getBatteryStatus(
        cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getGetBatteryStatusMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback> getRobotLocation(
        cmvr.api.AgvCommand.RobotStatusLocCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getGetRobotLocationMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback> robotConfigDownloadMap(
        cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getRobotConfigDownloadMapMethod(), getCallOptions()), request);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback> getMapStatus(
        cmvr.api.AgvCommand.RobotStatusMapCommand.Request request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getGetMapStatusMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_GET_STATUS_INFO = 0;
  private static final int METHODID_GET_BATTERY_STATUS = 1;
  private static final int METHODID_GET_ROBOT_LOCATION = 2;
  private static final int METHODID_ROBOT_CONFIG_DOWNLOAD_MAP = 3;
  private static final int METHODID_GET_MAP_STATUS = 4;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final AgvServiceImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(AgvServiceImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_GET_STATUS_INFO:
          serviceImpl.getStatusInfo((cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.GetAgvStatusInfoCommand.Feedback>) responseObserver);
          break;
        case METHODID_GET_BATTERY_STATUS:
          serviceImpl.getBatteryStatus((cmvr.api.AgvCommand.RobotStatusBatteryCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotStatusBatteryCommand.Feedback>) responseObserver);
          break;
        case METHODID_GET_ROBOT_LOCATION:
          serviceImpl.getRobotLocation((cmvr.api.AgvCommand.RobotStatusLocCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotStatusLocCommand.Feedback>) responseObserver);
          break;
        case METHODID_ROBOT_CONFIG_DOWNLOAD_MAP:
          serviceImpl.robotConfigDownloadMap((cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotConfigDownloadMapCommand.Feedback>) responseObserver);
          break;
        case METHODID_GET_MAP_STATUS:
          serviceImpl.getMapStatus((cmvr.api.AgvCommand.RobotStatusMapCommand.Request) request,
              (io.grpc.stub.StreamObserver<cmvr.api.AgvCommand.RobotStatusMapCommand.Feedback>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class AgvServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    AgvServiceBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return cmvr.api.AgvServiceOuterClass.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("AgvService");
    }
  }

  private static final class AgvServiceFileDescriptorSupplier
      extends AgvServiceBaseDescriptorSupplier {
    AgvServiceFileDescriptorSupplier() {}
  }

  private static final class AgvServiceMethodDescriptorSupplier
      extends AgvServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    AgvServiceMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (AgvServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new AgvServiceFileDescriptorSupplier())
              .addMethod(getGetStatusInfoMethod())
              .addMethod(getGetBatteryStatusMethod())
              .addMethod(getGetRobotLocationMethod())
              .addMethod(getRobotConfigDownloadMapMethod())
              .addMethod(getGetMapStatusMethod())
              .build();
        }
      }
    }
    return result;
  }
}
